Index: trunk/prototype/modules/calendar/js/calendar.codecs.js
===================================================================
--- trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 5953)
+++ trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 6066)
@@ -2,81 +2,87 @@
   
     init: function(){
-		this.moduleName = 'expressoCalendar'; 
-		this.me = DataLayer.dispatch( "me" );
-		
-		
-		this.timezones = Timezone.timezones;
-		this.isDaylightSaving = Timezone.daylightSaving;
-		this.load();      
+	this.moduleName = 'expressoCalendar'; 
+	this.me = DataLayer.dispatch( "me" );
+		
+		
+	this.timezones = Timezone.timezones;
+	this.isDaylightSaving = Timezone.daylightSaving;
+	this.load();      
     },             
   
     load: function(){
 
-		var defaultPreferences = { dateFormat: "dd/MM/yyyy",
-			hourFormat: "HH:mm",
-			defaultCalView: "month",
-			defaultDuration: 30,
-			backgroundColor: "36C",
-			borderColor: "36C",
-			fontColor: "fff",
-			timezone: 'America/Sao_Paulo',
-			weekStart: 'SUN'
-		  };
-
-		var pref = DataLayer.get( "modulePreference:detail", ['and',[ "=", "user", this.me.id ], [ "=", "module", this.moduleName ]] );
-
-		this.preferences = DataLayer.merge( defaultPreferences, pref.values || {} );
-		this.preferenceIds = pref.ids;
+	var defaultPreferences = {
+	    dateFormat: "dd/MM/yyyy",
+	    hourFormat: "HH:mm",
+	    defaultCalView: "month",
+	    defaultDuration: 30,
+	    backgroundColor: "36C",
+	    borderColor: "36C",
+	    fontColor: "fff",
+	    timezone: 'America/Sao_Paulo',
+	    weekStart: 'SUN'
+	};
+
+	var pref = DataLayer.get( "modulePreference:detail", ['and',[ "=", "user", this.me.id ], [ "=", "module", this.moduleName ]] );
+
+	this.preferences = DataLayer.merge( defaultPreferences, pref.values || {} );
+	this.preferenceIds = pref.ids;
     }
 }
 
 constantsParticipant = {
-	'o' : 'organization',
-	'w' : 'write',
-	'p' : 'participationRequired',
-	'i' : 'inviteGuests',
-	'r' : 'read'
+    'o' : 'organization',
+    'w' : 'write',
+    'p' : 'participationRequired',
+    'i' : 'inviteGuests',
+    'r' : 'read'
 }
 
 constantsCalendarShared = {
-	'r' : 'read',
-	'w' : 'write',
-	'd' : 'remove',
-	'b' : 'busy',
-	's' : 'shared',
-        'p' : 'required'
+    'r' : 'read',
+    'w' : 'write',
+    'd' : 'remove',
+    'b' : 'busy',
+    's' : 'shared',
+    'p' : 'required'
 }
 
 UI = {
-	dialogs: {
-		addEvent: null,
-		importCalendar: null,
-		sharedCalendar: null,
-		copyCalendar: null
-	}
+    dialogs: {
+	addEvent: null,
+	importCalendar: null,
+	sharedCalendar: null,
+	copyCalendar: null
+    }
 }
 
 DataLayer.codec( "calendarSignature", "calendar", {
   
-	decoder: function(){},
+    decoder: function(){},
       
-	encoder: function( signatures ){
-		return $.map( signatures, function( signature ){
-			return { events: function( start, end, callback ){
-				var viewKey = start + ':' + end;
-				if( Calendar.currentViewKey !== viewKey ){
-				    Calendar.currentViewKey = viewKey;
-				    Calendar.currentView = DataLayer.get( 'schedulable:calendar', { start: start, end: end } );
-				}
-				var view = Calendar.currentView[ signature.calendar.id ];
-				callback( view && !view.hidden ? view : [] );
-			   },
-
-			   backgroundColor: '#' + signature.backgroundColor || User.preferences.backgroundColor,
-			   borderColor: '#' + signature.borderColor || User.preferences.borderColor,
-			   textColor: '#' + signature.fontColor || User.preferences.fontColor,
-			   editable:  signature.isOwner }
-	       });
-      }
+    encoder: function( signatures ){
+	return $.map( signatures, function( signature ){
+	    return {
+		events: function( start, end, callback ){
+		    var viewKey = start + ':' + end;
+		    if( Calendar.currentViewKey !== viewKey ){
+			Calendar.currentViewKey = viewKey;
+			Calendar.currentView = DataLayer.get( 'schedulable:calendar', {
+			    start: start, 
+			    end: end
+			} );
+		    }
+		    var view = Calendar.currentView[ signature.calendar.id ];
+		    callback( view && !view.hidden ? view : [] );
+		},
+
+		backgroundColor: '#' + signature.backgroundColor || User.preferences.backgroundColor,
+		borderColor: '#' + signature.borderColor || User.preferences.borderColor,
+		textColor: '#' + signature.fontColor || User.preferences.fontColor,
+		editable:  signature.isOwner
+		}
+	});
+    }
 
       
@@ -84,6 +90,6 @@
 
 DataLayer.codec( "calendarToPermission", "detail", {
-	decoder: function( evtObj ){
-/*		Encoder.EncodeType = "entity";
+    decoder: function( evtObj ){
+    /*		Encoder.EncodeType = "entity";
 		
 		if( notArray = $.type(evtObj) !== "array" )
@@ -103,36 +109,36 @@
 	return notArray ? res[0] : res;
 	*/
-	},
+    },
 
     encoder: function( evtObj ){
 	
-		if(evtObj == "")
-			return "";
+	if(evtObj == "")
+	    return "";
 			
-		var notArray = false;
+	var notArray = false;
 		  
-		if( notArray = $.type(evtObj) !== "array" )
-			evtObj = [ evtObj ];
-		
-		var constantAcl = function(acl){
-			var returns = {};
-			for (var i in constantsCalendarShared){
-				returns[constantsCalendarShared[i]] = acl.indexOf(i) >= 0 ? true : false
-			}
-			return returns;
-		};
-
-		var res = $.map(evtObj, function( objEvent ){			
-			return {
-			    id: objEvent.id,
-			    type: objEvent.type,
-			    calendar: objEvent.calendar,
-			    user: objEvent.user,
-				acl: constantAcl(objEvent.acl)	,
-				aclValues: objEvent.acl
-			};
-		});	
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+		
+	var constantAcl = function(acl){
+	    var returns = {};
+	    for (var i in constantsCalendarShared){
+		returns[constantsCalendarShared[i]] = acl.indexOf(i) >= 0 ? true : false
+	    }
+	    return returns;
+	};
+
+	var res = $.map(evtObj, function( objEvent ){			
+	    return {
+		id: objEvent.id,
+		type: objEvent.type,
+		calendar: objEvent.calendar,
+		user: objEvent.user,
+		acl: constantAcl(objEvent.acl)	,
+		aclValues: objEvent.acl
+	    };
+	});	
 	return notArray ? res[0] : res;
-	}
+    }
 });
 
@@ -140,126 +146,144 @@
 Calendar = {
   
-	load: function(){
-		this.lastView = 0;
-		var filter = ['=', 'user', User.me.id];
-		if(!!User.me.gidNumber){
-			if(!$.isArray(User.me.gidNumber))
-				User.me.gidNumber = [User.me.gidNumber];
-
-			filter = ['OR', filter, ['IN', 'user', User.me.gidNumber]];
-		}
-
-		//var descart = DataLayer.get("calendarSignature", {filter: filter, criteria: {deepness: 2}});
-		this.signatures  = DataLayer.get("calendarSignature", {filter: filter, criteria: {deepness: 2}});
+    load: function(){
+	this.lastView = 0;
+	var filter = ['=', 'user', User.me.id];
+	if(!!User.me.gidNumber){
+	    if(!$.isArray(User.me.gidNumber))
+		User.me.gidNumber = [User.me.gidNumber];
+
+	    filter = ['OR', filter, ['IN', 'user', User.me.gidNumber]];
+	}
+
+	//var descart = DataLayer.get("calendarSignature", {filter: filter, criteria: {deepness: 2}});
+	this.signatures  = DataLayer.get("calendarSignature", {
+	    filter: filter, 
+	    criteria: {
+		deepness: 2
+	    }
+	});
 	  
-		var prevSources = this.sources;
-
-		this.sources = DataLayer.encode( "calendarSignature:calendar", this.signatures );
-
-		if( prevSources ){     
-			var newSources = DataLayer.diff( { 'diff': prevSources }, { 'diff': this.sources } ).diff;
-
-			for( var i = 0; i < newSources.length; i++ )
-				$('#calendar').fullCalendar( 'addEventSource', newSources[i] );
-
-			var removeSources = DataLayer.diff( { 'diff': newSources }, { 'diff': prevSources } ).diff;
-
-			for( var i = 0; i < removeSources.length; i++ )
-				$('#calendar').fullCalendar( 'removeEventSource', removeSources[i] );
-		}
-
-		this.calendarIds = [], this.signatureOf = {}, this.calendars = [], this.calendarOf= {};
-
-		for( var i = 0; i < this.signatures.length; i++ ){
-			if(this.signatures[i].isOwner == "0")
-				this.signatures[i].permission =  DataLayer.encode('calendarToPermission:detail', this.signatures[i].permission);
-			this.signatureOf[ this.calendarIds[i] = ( this.calendars[ this.calendars.length ] = this.calendarOf[ this.signatures[i].id ] = this.signatures[i].calendar ).id ] = this.signatures[i];
-		}
-
-		delete Calendar.currentViewKey;
-	},
-
-	rerenderView: function(force){
-
-		if(force){
-                        delete Calendar.currentViewKey;
+    var prevSources = this.sources;
+
+    this.sources = DataLayer.encode( "calendarSignature:calendar", this.signatures );
+
+    if( prevSources ){     
+	var newSources = DataLayer.diff( {
+	    'diff': prevSources
+	}, {
+	    'diff': this.sources
+	    } ).diff;
+
+	for( var i = 0; i < newSources.length; i++ )
+	    $('#calendar').fullCalendar( 'addEventSource', newSources[i] );
+
+	var removeSources = DataLayer.diff( {
+	    'diff': newSources
+	}, {
+	    'diff': prevSources
+	} ).diff;
+
+	for( var i = 0; i < removeSources.length; i++ )
+	    $('#calendar').fullCalendar( 'removeEventSource', removeSources[i] );
+    }
+
+    this.calendarIds = [], this.signatureOf = {}, this.calendars = [], this.calendarOf= {};
+
+    for( var i = 0; i < this.signatures.length; i++ ){
+	if(this.signatures[i].isOwner == "0")
+	    this.signatures[i].permission =  DataLayer.encode('calendarToPermission:detail', this.signatures[i].permission);
+	this.signatureOf[ this.calendarIds[i] = ( this.calendars[ this.calendars.length ] = this.calendarOf[ this.signatures[i].id ] = this.signatures[i].calendar ).id ] = this.signatures[i];
+    }
+
+    delete Calendar.currentViewKey;
+},
+
+rerenderView: function(force){
+
+    if(force){
+	delete Calendar.currentViewKey;
                         
-			$('#calendar').fullCalendar( 'refetchEvents' );
-		}
-
-		var calendarNotSelected = getSelectedCalendars( true );
-		for(var i = 0; i < calendarNotSelected.length; i++)
-			if(!!Calendar.currentView[ calendarNotSelected[i] ])
-				Calendar.currentView[ calendarNotSelected[i] ].hidden = true;
-
-		$('#calendar').fullCalendar( 'refetchEvents' );	
+	$('#calendar').fullCalendar( 'refetchEvents' );
+    }
+
+    var calendarNotSelected = getSelectedCalendars( true );
+    for(var i = 0; i < calendarNotSelected.length; i++)
+	if(!!Calendar.currentView[ calendarNotSelected[i] ])
+	    Calendar.currentView[ calendarNotSelected[i] ].hidden = true;
+
+    $('#calendar').fullCalendar( 'refetchEvents' );	
                 
-                contentMenu();
+    contentMenu();
+}
+}
+
+Alarms = {
+    load: function(){
+	var eventsDay = DataLayer.get('alarm:schedulable',['=', 'date', Date.today().getTime()]);
+	for(var i = 0; i < eventsDay.length; i++){
+	    this.addAlarm( eventsDay[i] );
 	}
+    },
+	
+    addAlarm: function( eventDay ){            
+	if(!DataLayer.tasks[parseInt(eventDay.sendTime)]){
+	    DataLayer.task( parseInt(eventDay.sendTime) , function( timestamp ){
+		var path = User.moduleName == 'expressoCalendar' ? '' : '../prototype/modules/calendar/';
+		DataLayer.render(path+'templates/alarm.ejs',{
+		    event: eventDay
+		}, function( html ){                                
+		    $.Zebra_Dialog(html , {
+			'type':     'question',
+			'overlay_opacity': '0.5',
+			'buttons':  ['Fechar'],
+			'onClose':  function(clicked) {}
+		    });
+		});
+	    });
+	}
+    }
 }
 
-Alarms = {
-	load: function(){
-		var eventsDay = DataLayer.get('alarm:schedulable',['=', 'date', Date.today().getTime()]);
-		for(var i = 0; i < eventsDay.length; i++){
-			this.addAlarm( eventsDay[i] );
-		}
-        },
-	
-	addAlarm: function( eventDay ){            
-                if(!DataLayer.tasks[parseInt(eventDay.sendTime)]){
-                    DataLayer.task( parseInt(eventDay.sendTime) , function( timestamp ){
-                        var path = User.moduleName == 'expressoCalendar' ? '' : '../prototype/modules/calendar/';
-                        DataLayer.render(path+'templates/alarm.ejs',{event: eventDay}, function( html ){                                
-                                $.Zebra_Dialog(html , {
-                                    'type':     'question',
-                                    'overlay_opacity': '0.5',
-                                    'buttons':  ['Fechar'],
-                                    'onClose':  function(clicked) {}
-                               });
-			});
-                    });
-                }
+DataLayer.codec( "modulePreference", "detail", {
+    decoder: function( evtObj ){
+
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+		
+	var res = $.map(evtObj, function( form ){
+
+	    var returns = [];
+
+	    for (var name in form)
+		returns[ returns.length ] = {
+		    name: name,
+		    user: User.me.id,
+		    value: form[name],
+		    module: User.moduleName,
+		    id: User.preferenceIds[ name ] || undefined
+		};
+
+	    return [returns];
+	});
+	
+	return notArray ? res[0] : res;
+    },
+
+    encoder: function( evtObj ){
+	var val = {}, id = {};
+	for (var i in evtObj){
+			
+	    if( evtObj[i].value && evtObj[i].id )
+	    {
+		val[evtObj[i].name] = evtObj[i].value;
+		id[evtObj[i].name] = evtObj[i].id;
+	    }
 	}
-}
-
-DataLayer.codec( "modulePreference", "detail", {
-	decoder: function( evtObj ){
-
-	if( notArray = $.type(evtObj) !== "array" )
-		evtObj = [ evtObj ];
-		
-		var res = $.map(evtObj, function( form ){
-
-			var returns = [];
-
-			for (var name in form)
-				returns[ returns.length ] = {
-					name: name,
-					user: User.me.id,
-					value: form[name],
-					module: User.moduleName,
-					id: User.preferenceIds[ name ] || undefined
-				};
-
-			return [returns];
-		});
-	
-	return notArray ? res[0] : res;
-	},
-
-    encoder: function( evtObj ){
-		var val = {}, id = {};
-		for (var i in evtObj){
-			
-			if( evtObj[i].value && evtObj[i].id )
-			{
-			    val[evtObj[i].name] = evtObj[i].value;
-			    id[evtObj[i].name] = evtObj[i].id;
-			}
-		}
-		return {values: val,ids: id};
-	
-	}
+	return {
+	    values: val,
+	    ids: id
+	};
+	
+    }
 });
 
@@ -273,12 +297,12 @@
   
     if( status === 'serverclient' ){
-		DataLayer.commit( false, false, function(){	
-			if((typeof($tabs) != "undefined") && $tabs.tabs('option' ,'selected') == 0){
-                                Calendar.rerenderView(true);
-			}else if((typeof($tabs) != "undefined") && $tabs.tabs('option' ,'selected') != 0)
-				pageselectCallback($('.events-list-win.active [name=keyword]').val(), 0);
-                        //Recarrega os alarmes de eventos    
-                        Alarms.load();
-		});
+	DataLayer.commit( false, false, function(){	
+	    if((typeof($tabs) != "undefined") && $tabs.tabs('option' ,'selected') == 0){
+		Calendar.rerenderView(true);
+	    }else if((typeof($tabs) != "undefined") && $tabs.tabs('option' ,'selected') != 0)
+		pageselectCallback($('.events-list-win.active [name=keyword]').val(), 0);
+	    //Recarrega os alarmes de eventos    
+	    Alarms.load();
+	});
     }
 });
@@ -304,10 +328,11 @@
 
     switch( status ){
-		case 'serverclient':  DataLayer.commit( false, false, function(){
-			User.load();
-		});
-		break;
-		case 'client':  
-		break;
+	case 'serverclient':
+	    DataLayer.commit( false, false, function(){
+	    User.load();
+	});
+	break;
+	case 'client':
+	    break;
     }
 
@@ -316,5 +341,5 @@
 DataLayer.listen( "alarm", function( created, updated, deleted ){
 
-});
+    });
 
 /*DataLayer.listen( "calendar", function( status, updateData ){
@@ -335,42 +360,51 @@
 
 DataLayer.codec( "calendarSignature", "configure", {
-	decoder: function( evtObj ){
-		Encoder.EncodeType = "entity";
-		
-		if( notArray = $.type(evtObj) !== "array" )
-			evtObj = [ evtObj ];
-		
-		var res = $.map(evtObj, function( form ){
-			return{
-				id: form.signature,
-				user: User.me.id,	
-				calendar: {
-					id: Calendar.calendarOf[form.signature].id,
-					name: Encoder.htmlEncode(form.name),
-					description: Encoder.htmlEncode(form.description),
-					timezone: form.timezone,
-					defaultDuration: form.duration != "" ? form.duration : 30,
-					location: form.location
-				},
-			//	isOwner: 1,
-				fontColor: Encoder.htmlEncode(form.fontColor.substring(1)),
-				backgroundColor: Encoder.htmlEncode(form.backgroundColor.substring(1)),
-				borderColor: Encoder.htmlEncode(form.borderColor.substring(1)),
-				msgAdd: Encoder.htmlEncode(form.msgAdd),
-				msgCancel: Encoder.htmlEncode(form.msgCancel),
-				msgUpdate: Encoder.htmlEncode(form.msgUpdate),
-				msgReply: Encoder.htmlEncode(form.msgReply),
-				msgAlarm: Encoder.htmlEncode(form.msgAlarm),
-				calendarSignatureAlarms: $.map( form.alarmTime || [], function( alarmTime, i ){
-					return (!!form.alarmId[i] ?
-							{type: form.alarmType[i],	unit: form.alarmUnit[i], time: form.alarmTime[i], id: form.alarmId[i]} :
-							{type: form.alarmType[i],	unit: form.alarmUnit[i], time: form.alarmTime[i]});
-				})
-			};
-		
-		});
+    decoder: function( evtObj ){
+	Encoder.EncodeType = "entity";
+		
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+		
+	var res = $.map(evtObj, function( form ){
+	    return{
+		id: form.signature,
+		user: User.me.id,	
+		calendar: {
+		    id: Calendar.calendarOf[form.signature].id,
+		    name: Encoder.htmlEncode(form.name),
+		    description: Encoder.htmlEncode(form.description),
+		    timezone: form.timezone,
+		    defaultDuration: form.duration != "" ? form.duration : 30,
+		    location: form.location
+		},
+		//	isOwner: 1,
+		fontColor: Encoder.htmlEncode(form.fontColor.substring(1)),
+		backgroundColor: Encoder.htmlEncode(form.backgroundColor.substring(1)),
+		borderColor: Encoder.htmlEncode(form.borderColor.substring(1)),
+		msgAdd: Encoder.htmlEncode(form.msgAdd),
+		msgCancel: Encoder.htmlEncode(form.msgCancel),
+		msgUpdate: Encoder.htmlEncode(form.msgUpdate),
+		msgReply: Encoder.htmlEncode(form.msgReply),
+		msgAlarm: Encoder.htmlEncode(form.msgAlarm),
+		calendarSignatureAlarms: $.map( form.alarmTime || [], function( alarmTime, i ){
+		    return (!!form.alarmId[i] ?
+		    {
+			type: form.alarmType[i],	
+			unit: form.alarmUnit[i], 
+			time: form.alarmTime[i], 
+			id: form.alarmId[i]
+			} :
+{
+			type: form.alarmType[i],	
+			unit: form.alarmUnit[i], 
+			time: form.alarmTime[i]
+			});
+		})
+	    };
+		
+	});
 	
 	return notArray ? res[0] : res;
-	},
+    },
 
     encoder: function( evtObj ){}
@@ -381,28 +415,28 @@
     decoder: function( evtObj ){},
 	
-	encoder: function (evtObjt){
-	
-			if(notArray = typeof(evtObjt) == 'array' )
-				evtObjt = [evtObjt];
+    encoder: function (evtObjt){
+	
+	if(notArray = typeof(evtObjt) == 'array' )
+	    evtObjt = [evtObjt];
 			
-			var res = $.map(evtObjt, function( objEvent ){	
-
-				var time = parseInt(objEvent.schedulable.startTime);
+	var res = $.map(evtObjt, function( objEvent ){	
+
+	    var time = parseInt(objEvent.schedulable.startTime);
 											
-				return{
-					id: objEvent.id,
-					event_start: new Date( time ).setTimezoneOffset(Timezone.timezones[objEvent.schedulable.timezone]).toString( User.preferences.dateFormat),
-					sendTime: objEvent.sendTime,
-					schedulable: {
-						startTime: dateCalendar.formatDate(Timezone.getDateEvent(new Date(time), objEvent.schedulable.timezone, objEvent.schedulable.DayLigth, 'startTime'), User.preferences.hourFormat),
-						id: objEvent.schedulable.id,
-						summary: objEvent.schedulable.summary,
-						time: objEvent.time,	
-						unit: dateCalendar.timeunit[objEvent.unit.toLowerCase()] + ( parseInt(objEvent.time) > 1 ? 's' : '' )
-					}
-				}
-			});
-		return notArray ? res[0] : res;
-	}
+	    return{
+		id: objEvent.id,
+		event_start: new Date( time ).setTimezoneOffset(Timezone.timezones[objEvent.schedulable.timezone]).toString( User.preferences.dateFormat),
+		sendTime: objEvent.sendTime,
+		schedulable: {
+		    startTime: dateCalendar.formatDate(Timezone.getDateEvent(new Date(time), objEvent.schedulable.timezone, objEvent.schedulable.DayLigth, 'startTime'), User.preferences.hourFormat),
+		    id: objEvent.schedulable.id,
+		    summary: objEvent.schedulable.summary,
+		    time: objEvent.time,	
+		    unit: dateCalendar.timeunit[objEvent.unit.toLowerCase()] + ( parseInt(objEvent.time) > 1 ? 's' : '' )
+		}
+	    }
+	});
+	return notArray ? res[0] : res;
+    }
 });
 
@@ -410,30 +444,30 @@
 
     decoder: function( evtObj ){
-		if( notArray = $.type(evtObj) !== "array" )
-			evtObj = [ evtObj ];
-
-
-
-		var meAttendee = function(attendees){
-			for(var i = 0; i < attendees.length; i++)
-				if(DataLayer.get('participant', attendees[i]).user == User.me.id)
-					return attendee;
-		};
-
-		var res = $.map(evtObj, function( form ){	
-			return {
-				participant : meAttendee(form.attendee), 
-				startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
-				endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),
-				allDay: ( !!form.allDay ? 1 : 0 ),
-				schedulable: form.idEvent
-			}
-		});	
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+
+
+
+	var meAttendee = function(attendees){
+	    for(var i = 0; i < attendees.length; i++)
+		if(DataLayer.get('participant', attendees[i]).user == User.me.id)
+		    return attendee;
+	};
+
+	var res = $.map(evtObj, function( form ){	
+	    return {
+		participant : meAttendee(form.attendee), 
+		startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
+		endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),
+		allDay: ( !!form.allDay ? 1 : 0 ),
+		schedulable: form.idEvent
+	    }
+	});	
 	
 
 	return notArray ? res[0] : res;
-	},
-	
-	encoder: function( evtObj ){}
+    },
+	
+    encoder: function( evtObj ){}
 	
 });
@@ -441,18 +475,20 @@
 DataLayer.codec( "attachment", "detail", {
   
-	decoder: function(evtObj){
-	
-		if( notArray = $.type(evtObj) !== "array" )
-			evtObj = [ evtObj ];
-
-		var res = $.map(evtObj, function( form){
-			return [$.map(form.files , function( files){
-					return { source: files };
-				})];
-		});
+    decoder: function(evtObj){
+	
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+
+	var res = $.map(evtObj, function( form){
+	    return [$.map(form.files , function( files){
+		return {
+		    source: files
+		};
+	    })];
+	});
 	return notArray ? res[0] : res;
-	},
+    },
       
-	encoder: function(){}
+    encoder: function(){}
 
       
@@ -462,69 +498,78 @@
 
     decoder: function( evtObj ){
-		Encoder.EncodeType = "entity";
-	
-		if( notArray = $.type(evtObj) !== "array" )
-			evtObj = [ evtObj ];
-
-		var pref = User.preferences;
-		
-		var Owner = decodeOwnerCalendar(evtObj.calendar);	
-
-		var res = $.map(evtObj, function( form ){
+	Encoder.EncodeType = "entity";
+	
+	if( notArray = $.type(evtObj) !== "array" )
+	    evtObj = [ evtObj ];
+
+	var pref = User.preferences;
+		
+	var Owner = decodeOwnerCalendar(evtObj.calendar);	
+
+	var res = $.map(evtObj, function( form ){
 			
-			return {
-				id: form.idEvent,
-				calendar: form.calendar,
-				participants : $.map(form.attendee, function( attendee, i ){
-					if(isNaN(attendee)){
-					    return{
-						    id: attendee,
-						    acl: form.attendeeAcl[i],
-						    delegatedFrom: !!form.delegatedFrom[i] ? form.delegatedFrom[i] : 0,
-						    isOrganizer: (form.attendee_organizer == attendee ? 1 : 0 ),
-						    isExternal: !!parseInt(form.attendeeType[i]) ? 1 : 0,
-						    acl: form.attendeeAcl[i].replace('o', '')
-					    };
-					}else{
-						if(DataLayer.get('participant', attendee).user == Owner.id){
-							var me = {
-							    user: User.id,
-							    status: form.status,
-							    id: attendee,
-							    isOrganizer: 0,
-							    receiveNotification : (!!form.receiveNotification ? 1 : 0),
-							    alarms: typeof(form.alarmTime) != 'undefined' ? 
-								$.map( form.alarmTime || [], function( alarmTime, i ){
-
-								    if( alarmTime === "" )
-									    return( null );
-
-								    return !!form.alarmId[i] ?
-									    { type: form.alarmType[i], unit: form.alarmUnit[i], time: form.alarmTime[i], id: form.alarmId[i] } : 
-									    { type: form.alarmType[i],unit: form.alarmUnit[i], time: form.alarmTime[i] };
-								    }) : []
-						    };
+	    return {
+		id: form.idEvent,
+		calendar: form.calendar,
+		participants : $.map(form.attendee, function( attendee, i ){
+		    if(isNaN(attendee)){
+			return{
+			    id: attendee,
+			    acl: form.attendeeAcl[i],
+			    delegatedFrom: !!form.delegatedFrom[i] ? form.delegatedFrom[i] : 0,
+			    isOrganizer: (form.attendee_organizer == attendee ? 1 : 0 ),
+			    isExternal: !!parseInt(form.attendeeType[i]) ? 1 : 0,
+			    acl: form.attendeeAcl[i].replace('o', '')
+			};
+		    }else{
+			if(DataLayer.get('participant', attendee).user == Owner.id){
+			    var me = {
+				user: User.id,
+				status: form.status,
+				id: attendee,
+				isOrganizer: 0,
+				receiveNotification : (!!form.receiveNotification ? 1 : 0),
+				alarms: typeof(form.alarmTime) != 'undefined' ? 
+				$.map( form.alarmTime || [], function( alarmTime, i ){
+
+				    if( alarmTime === "" )
+					return( null );
+
+				    return !!form.alarmId[i] ?
+				    {
+					type: form.alarmType[i], 
+					unit: form.alarmUnit[i], 
+					time: form.alarmTime[i], 
+					id: form.alarmId[i]
+					} : 
+{
+					type: form.alarmType[i],
+					unit: form.alarmUnit[i], 
+					time: form.alarmTime[i]
+					};
+				}) : []
+			    };
 							
-							if(form.startDate){
-								var tzId =  DataLayer.get('schedulable', form.idEvent).timezone || User.preferences.timezone,
-								formatString = ( typeof form.allDay !== "undefined" && !!form.allDay )? pref.dateFormat+" HH:mm" : pref.dateFormat + " " + pref.hourFormat;
+			    if(form.startDate){
+				var tzId =  DataLayer.get('schedulable', form.idEvent).timezone || User.preferences.timezone,
+				formatString = ( typeof form.allDay !== "undefined" && !!form.allDay )? pref.dateFormat+" HH:mm" : pref.dateFormat + " " + pref.hourFormat;
 								
-								DataLayer.put('notification', {
-								    participant: me.id,
-								    type: 'suggestion',
-								    startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
-								    endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),
-								    allDay: ( !!form.allDay ? 1 : 0 ),
-								    schedulable: form.idEvent
-								});
+				DataLayer.put('notification', {
+				    participant: me.id,
+				    type: 'suggestion',
+				    startTime: Date.parseExact(form.startDate + (!!form.allDay ? " 00:00": " "+$.trim(form.startHour)) , formatString ).toString('yyyy-MM-dd HH:mm:00'),
+				    endTime:  Date.parseExact(form.endDate + ( !!form.allDay ? " 00:00": " "+$.trim(form.endHour)), formatString ).toString('yyyy-MM-dd HH:mm:00'),
+				    allDay: ( !!form.allDay ? 1 : 0 ),
+				    schedulable: form.idEvent
+				});
 							
-							}
-							return me;
-						}else return(null);
-					};
-				})
-			}
-		});
-		return notArray ? res[0] : res;
+			    }
+			    return me;
+			}else return(null);
+		    };
+		})
+	    }
+	});
+	return notArray ? res[0] : res;
     },
 
